<template>
    <div class="app-tree-select">
        <el-select v-model="currentVal" popper-class="app-tree-select__dropdown" :readonly="readonly" :disabled="disabled" :multiple="multiple" clearable :placeholder="placeholder">
            <template slot="empty">
                <el-input v-model="searchValue" placeholder="输入关键字过滤" @input="onSearch"></el-input>
                <el-tree
                    ref="tree"
                    :data="items"
                    :show-checkbox="multiple"
                    :check-on-click-node="!multiple"
                    node-key="value"
                    :props="defaultProps"
                    :check-strictly="checkStrictly"
                    :default-checked-keys="defaultKeys"
                    :filter-node-method="filterNode"
                    @check="onTreeSelect"
                ></el-tree>
            </template>
        </el-select>
    </div>
</template>

<script lang="ts">
import CodeListService from "@/codelist/codelist-service";
import { Util } from "@/utils";
import { Subject, Subscription } from "rxjs";
import { Vue, Component, Prop, Watch, Model } from "vue-property-decorator";

@Component({})
export default class AppTreeSelect extends Vue {
    /**
     * 代码表服务对象
     *
     * @type {CodeListService}
     * @memberof AppTreeSelect
     */
    public codeListService: CodeListService = new CodeListService();

    /**
     * 额外参数
     *
     * @type {*}
     * @memberof AppTreeSelect
     */
    public otherParam: any;

    /**
     * 查询参数
     * @type {*}
     * @memberof AppTreeSelect
     */
    public queryParam: any;

    /**
     * 当前选中值
     * @type {any}
     * @memberof AppTreeSelect
     */
    @Model("change") readonly itemValue!: any;

    /**
     * 监控值变化，根据属性类型强制转换
     *
     * @memberof AppTreeSelect
     */
    @Watch("itemValue")
    public valueWatch() {
        try {
            if (this.itemValue) {
                const tree: any = this.$refs.tree;
                if (tree && this.multiple) {
                    tree.setCheckedKeys(this.itemValue);
                }
                if (this.items.length == 0) {
                    this.loadData();
                }
            }
        } catch (error) {
            console.log("下拉列表，值转换失败");
        }
    }

    /**
     * 代码表标识
     *
     * @type {string}
     * @memberof AppTreeSelect
     */
    @Prop() public tag?: string;

    /**
     * 代码表类型
     *
     * @type {string}
     * @memberof AppTreeSelect
     */
    @Prop() public codelistType?: string;

    /**
     * 传入表单数据
     *
     * @type {*}
     * @memberof AppTreeSelect
     */
    @Prop() public data?: any;

    /**
     * 表单状态对象
     *
     * @type {Subject<any>}
     * @memberof AppTreeSelect
     */
    @Prop() public formState!: Subject<any>;

    /**
     * 订阅对象
     *
     * @protected
     * @type {(Subscription | undefined)}
     * @memberof AppTreeSelect
     */
    protected formStateEvent: Subscription | undefined;

    /**
     * 局部上下文导航参数
     *
     * @type {*}
     * @memberof AppTreeSelect
     */
    @Prop() public localContext!: any;

    /**
     * 局部导航参数
     *
     * @type {*}
     * @memberof AppTreeSelect
     */
    @Prop() public localParam!: any;

    /**
     * 视图上下文
     *
     * @type {*}
     * @memberof AppAutocomplete
     */
    @Prop() public context!: any;

    /**
     * 视图参数
     *
     * @type {*}
     * @memberof AppFormDRUIPart
     */
    @Prop() public viewparams!: any;

    /**
     * 是否禁用
     * @type {any}
     * @memberof AppTreeSelect
     *
     */
    @Prop() public disabled?: any;

    /**
     * 是否支持过滤
     * @type {boolean}
     * @memberof AppTreeSelect
     */
    public filterable: boolean = true;

    /**
     * 下拉选提示内容
     * @type {string}
     * @memberof AppTreeSelect
     */
    @Prop() public placeholder?: string;

    /**
     * 属性类型
     *
     * @type {'string' | 'number'}
     * @memberof AppTreeSelect
     */
    @Prop({ default: "string" })
    public valueType!: "string" | "number";

    /**
     * 只读
     * @type {boolean}
     * @memberof AppTreeSelect
     */
    @Prop({ default: false }) public readonly?: boolean;

    /**
     * 多选
     * @type {boolean}
     * @memberof AppTreeSelect
     */
    @Prop({ default: false }) public multiple!: boolean;

    /**
     * 是否允许选中父节点
     * @type {boolean}
     * @memberof AppTreeSelect
     */
    @Prop({ default: false }) public parent!: boolean;

    /**
     * 父子不关联
     * @type {boolean}
     * @memberof AppTreeSelect
     */
    @Prop({ default: false }) public checkStrictly!: boolean;

    /**
     * 搜索值
     * @type {string}
     * @memberof AppTreeSelect
     */
    public searchValue: string = "";

    /**
     * 树默认参数
     * @type {any}
     * @memberof AppTreeSelect
     */
    public defaultProps: any = { label: "label" };

    /**
     * 树默认选中值
     * @type {boolean}
     * @memberof AppTreeSelect
     */
    public defaultKeys: string[] = [];

    /**
     * 设置值
     *
     * @memberof AppTreeSelect
     */
    set currentVal(value: any) {
        if (this.multiple) {
            let list: Array<any> = [];
            this.getItemList(list, this.items);
            const result: string[] = [];
            list.forEach((item: any) => {
                if (value.includes(item.label)) {
                    result.push(item.value);
                }
            });
            this.$emit("change", result);
        } else {
            this.$emit("change", value);
        }
    }

    /**
     * 获取值对象
     *
     * @memberof AppTreeSelect
     */
    get currentVal() {
        if (this.items.length > 0 && this.itemValue) {
            let list: Array<any> = [];
            this.getItemList(list, this.items);
            if (this.multiple) {
                this.defaultKeys = JSON.parse(JSON.stringify(this.itemValue));
                const labels: string[] = [];
                list.forEach((item: any) => {
                    if (this.itemValue.includes(item.value)) {
                        labels.push(item.label);
                    }
                });
                return labels;
            } else {
                const item = list.find((item: any) => Object.is(item.value, this.itemValue));
                return item.label;
            }
        }
        return "";
    }

    /**
     * 节点过滤
     *
     * @memberof AppTreeSelect
     */
    filterNode(value: string, data: any) {
        if (!value) return true;
        return data.label.indexOf(value) !== -1;
    }

    /**
     * 获取代码表列表
     *
     * @memberof AppTreeSelect
     */
    public getItemList(list: Array<any>, items: Array<any>) {
        if (items && items.length > 0) {
            items.forEach((item: any) => {
                if (item.children) {
                    this.getItemList(list, item.children);
                }
                list.push(item);
            });
        }
    }

    /**
     * 代码表
     *
     * @type {any[]}
     * @memberof AppTreeSelect
     */
    public items: any[] = [];

    /**
     * 公共参数处理
     *
     * @param {*} arg
     * @returns
     * @memberof AppTreeSelect
     */
    public handlePublicParams(arg: any) {
        // 合并表单参数
        arg.param = this.viewparams ? JSON.parse(JSON.stringify(this.viewparams)) : {};
        arg.context = this.context ? JSON.parse(JSON.stringify(this.context)) : {};
        // 附加参数处理
        if (this.localContext && Object.keys(this.localContext).length > 0) {
            let _context = this.$util.computedNavData(this.data, arg.context, arg.param, this.localContext);
            Object.assign(arg.context, _context);
        }
        if (this.localParam && Object.keys(this.localParam).length > 0) {
            let _param = this.$util.computedNavData(this.data, arg.context, arg.param, this.localParam);
            Object.assign(arg.param, _param);
        }
    }

    /**
     * vue  生命周期
     *
     * @memberof AppTreeSelect
     */
    public created() {
        if (this.formState) {
            this.formStateEvent = this.formState.subscribe(({ type, data }) => {
                if (Object.is("load", type)) {
                    this.loadData();
                }
            });
        }
        if (this.items.length == 0) {
            this.loadData();
        }
    }

    /**
     * 加载数据
     *
     * @memberof AppTreeSelect
     */
    public loadData() {
        if (this.tag && Object.is(this.codelistType, "STATIC")) {
            const codelist = this.$store.getters.getCodeList(this.tag);
            if (codelist) {
                let items: Array<any> = [...JSON.parse(JSON.stringify(codelist.items))];
                this.formatCodeList(items);
            } else {
                console.log(`----${this.tag}----代码表不存在`);
            }
        } else if (this.tag && Object.is(this.codelistType, "DYNAMIC")) {
            // 公共参数处理
            let data: any = {};
            this.handlePublicParams(data);
            // 参数处理
            let _context = data.context;
            let _param = data.param;
            this.codeListService
                .getItems(this.tag, _context, _param)
                .then((res: any) => {
                    let items: Array<any> = [...res];
                    this.formatCodeList(items);
                })
                .catch((error: any) => {
                    console.log(`----${this.tag}----代码表不存在`);
                });
        }
    }

    /**
     * 树选中
     *
     * @memberof AppTreeSelect
     */
    public onTreeSelect(item: any, node: any) {
        if (this.multiple) {
            this.$emit("change", node.checkedKeys);
        } else {
            this.$emit("change", item.value);
        }
    }

    /**
     * 搜索
     *
     * @memberof AppTreeSelect
     */
    onSearch(query: string) {
        const tree: any = this.$refs.tree;
        if (tree) {
            tree.filter(query);
        }
    }

    /**
     * 代码表类型和属性匹配
     *
     * @param {*} items
     * @memberof AppTreeSelect
     */
    public formatCodeList(items: Array<any>) {
        let matching: boolean = false;
        this.items = [];
        try {
            items.forEach((item: any) => {
                const type = this.$util.typeOf(item.value);
                if (type != this.valueType) {
                    matching = true;
                    if (type === "number") {
                        item.value = item.value.toString();
                    } else {
                        if (type == "null") {
                            this.valueType == "number" ? (item.value = 0) : (item.value = "");
                        } else if (item.value.indexOf(".") == -1) {
                            item.value = parseInt(item.value);
                        } else {
                            item.value = parseFloat(item.value);
                        }
                    }
                }
                this.items.push(item);
            });
            if (matching) {
                console.warn(`代码表 ${this.tag} 值类型和属性类型不匹配，已自动强制转换，请修正代码表值类型和属性类型匹配`);
            }
        } catch (error) {
            console.warn("代码表值类型和属性类型不匹配，自动强制转换异常，请修正代码表值类型和属性类型匹配");
        }
        this.handleLevelCodeList(Util.deepCopy(this.items));
    }

    /**
     * 处理层级代码表
     *
     * @param {*} items
     * @memberof AppTreeSelect
     */
    public handleLevelCodeList(items: Array<any>) {
        if (items && items.length > 0) {
            const hasChildren = items.some((item: any) => {
                return item.pvalue;
            });
            if (hasChildren) {
                let list: Array<any> = [];
                items.forEach((codeItem: any) => {
                    if (!codeItem.pvalue) {
                        let valueField: string = codeItem.value;
                        this.setChildCodeItems(valueField, items, codeItem);
                        list.push(codeItem);
                    }
                });
                this.items = list;
            }
        }
    }

    /**
     * 计算子类代码表
     *
     * @param {*} items
     * @memberof AppTreeSelect
     */
    public setChildCodeItems(pValue: string, result: Array<any>, codeItem: any) {
        result.forEach((item: any) => {
            if (item.pvalue == pValue) {
                if (!this.parent) {
                    codeItem.disabled = true;
                }
                let valueField: string = item.value;
                this.setChildCodeItems(valueField, result, item);
                if (!codeItem.children) {
                    codeItem.children = [];
                }
                codeItem.children.push(item);
            }
        });
    }

    /**
     * vue 生命周期
     *
     * @memberof AppTreeSelect
     */
    public destroyed() {
        if (this.formStateEvent) {
            this.formStateEvent.unsubscribe();
        }
    }
}
</script>

<style lang="less">
@import "./app-tree-select.less";
</style>
